"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReadAlignment(ProtocolElement):
    """
    Each read alignment describes an alignment with additional information
    about the fragment and the read. A read alignment object is
    equivalent to a line in a SAM file.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "fragmentId",
        "fragmentName",
        "readGroupId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import ga4gh as ga4gh_3_0_0

        return {
            "alignment": ga4gh_3_0_0.LinearAlignment,
            "nextMatePosition": ga4gh_3_0_0.Position,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import ga4gh as ga4gh_3_0_0

        return {
            "org.ga4gh.models.LinearAlignment": ga4gh_3_0_0.LinearAlignment,
            "org.ga4gh.models.Position": ga4gh_3_0_0.Position,
            "org.ga4gh.models.ReadAlignment": ga4gh_3_0_0.ReadAlignment,
        }

    __slots__ = [
        "fragmentId",
        "fragmentName",
        "readGroupId",
        "alignedQuality",
        "alignedSequence",
        "alignment",
        "duplicateFragment",
        "failedVendorQualityChecks",
        "fragmentLength",
        "id",
        "info",
        "nextMatePosition",
        "numberReads",
        "properPlacement",
        "readNumber",
        "secondaryAlignment",
        "supplementaryAlignment",
    ]

    def __init__(
        self,
        fragmentId,
        fragmentName,
        readGroupId,
        alignedQuality=list,
        alignedSequence=None,
        alignment=None,
        duplicateFragment=None,
        failedVendorQualityChecks=None,
        fragmentLength=None,
        id=None,
        info=dict,
        nextMatePosition=None,
        numberReads=None,
        properPlacement=None,
        readNumber=None,
        secondaryAlignment=None,
        supplementaryAlignment=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_0_0.ReadAlignment model.

        :param fragmentId:
            The fragment ID that this ReadAlignment belongs to.
        :type fragmentId: str
        :param fragmentName:
            The fragment name. Equivalent to QNAME (query template name) in SAM.
        :type fragmentName: str
        :param readGroupId:
            The ID of the read group this read belongs to.   (Every read must
            belong to exactly one read group.)
        :type readGroupId: str
        :param alignedQuality:
            The quality of the read sequence contained in this alignment record.
            `alignedSequence` and `alignedQuality` may be shorter than
            the full read sequence   and quality. This will occur if
            the alignment is part of a chimeric alignment,   or if the
            read was trimmed. When this occurs, the CIGAR for this
            read will   begin/end with a hard clip operator that will
            indicate the length of the excised sequence.
        :type alignedQuality: list[int]
        :param alignedSequence:
            The bases of the read sequence contained in this alignment record.
            `alignedSequence` and `alignedQuality` may be shorter than
            the full read sequence   and quality. This will occur if
            the alignment is part of a chimeric alignment,   or if the
            read was trimmed. When this occurs, the CIGAR for this
            read will   begin/end with a hard clip operator that will
            indicate the length of the excised sequence.
        :type alignedSequence: None | str
        :param alignment:
            The alignment for this alignment record. This field will be null if
            the read   is unmapped.
        :type alignment: None | LinearAlignment
        :param duplicateFragment:
            The fragment is a PCR or optical duplicate (SAM flag 0x400)
        :type duplicateFragment: None | boolean
        :param failedVendorQualityChecks:
            SAM flag 0x200
        :type failedVendorQualityChecks: None | boolean
        :param fragmentLength:
            The observed length of the fragment, equivalent to TLEN in SAM.
        :type fragmentLength: None | int
        :param id:
            The read alignment ID. This ID is unique within the read group this
            alignment belongs to. This field may not be provided by
            all backends.   Its intended use is to make caching and UI
            display easier for   genome browsers and other light
            weight clients.
        :type id: None | str
        :param info:
            A map of additional read alignment information.
        :type info: dict[str, list[str]]
        :param nextMatePosition:
            The mapping of the primary alignment of the
            `(readNumber+1)%numberReads`   read in the fragment. It
            replaces mate position and mate strand in SAM.
        :type nextMatePosition: None | Position
        :param numberReads:
            The number of reads in the fragment (extension to SAM flag 0x1)
        :type numberReads: None | int
        :param properPlacement:
            The orientation and the distance between reads from the fragment are
            consistent with the sequencing protocol (equivalent to SAM
            flag 0x2)
        :type properPlacement: None | boolean
        :param readNumber:
            The read number in sequencing. 0-based and less than numberReads. This
            field   replaces SAM flag 0x40 and 0x80.
        :type readNumber: None | int
        :param secondaryAlignment:
            Whether this alignment is secondary. Equivalent to SAM flag 0x100.   A
            secondary alignment represents an alternative to the
            primary alignment   for this read. Aligners may return
            secondary alignments if a read can map   ambiguously to
            multiple coordinates in the genome.    By convention, each
            read has one and only one alignment where both
            secondaryAlignment and supplementaryAlignment are false.
        :type secondaryAlignment: None | boolean
        :param supplementaryAlignment:
            Whether this alignment is supplementary. Equivalent to SAM flag 0x800.
            Supplementary alignments are used in the representation of
            a chimeric   alignment. In a chimeric alignment, a read is
            split into multiple   linear alignments that map to
            different reference contigs. The first   linear alignment
            in the read will be designated as the representative
            alignment;   the remaining linear alignments will be
            designated as supplementary alignments.   These alignments
            may have different mapping quality scores.    In each
            linear alignment in a chimeric alignment, the read will be
            hard clipped.   The `alignedSequence` and `alignedQuality`
            fields in the alignment record will   only represent the
            bases for its respective linear alignment.
        :type supplementaryAlignment: None | boolean
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
